Index: trunk/src/VBox/VMM/testcase/Makefile.kmk
===================================================================
--- trunk/src/VBox/VMM/testcase/Makefile.kmk	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/Makefile.kmk	(revision 28800)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2006-2007 Sun Microsystems, Inc.
+# Copyright (C) 2006-2007 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
 # VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 # hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-#
-# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
-# Clara, CA 95054 USA or visit http://www.sun.com if you need
-# additional information or have any questions.
 #
 
Index: trunk/src/VBox/VMM/testcase/mkdsk.sh
===================================================================
--- trunk/src/VBox/VMM/testcase/mkdsk.sh	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/mkdsk.sh	(revision 28800)
@@ -1,5 +1,5 @@
 #!/bin/sh
 #
-# Copyright (C) 2006-2007 Sun Microsystems, Inc.
+# Copyright (C) 2006-2007 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -10,8 +10,4 @@
 # VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 # hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-#
-# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
-# Clara, CA 95054 USA or visit http://www.sun.com if you need
-# additional information or have any questions.
 #
 
Index: trunk/src/VBox/VMM/testcase/tstAnimate.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstAnimate.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstAnimate.cpp	(revision 28800)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2007 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstAsmStructs.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstAsmStructs.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstAsmStructs.cpp	(revision 28800)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2007 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstAsmStructsAsm.asm
===================================================================
--- trunk/src/VBox/VMM/testcase/tstAsmStructsAsm.asm	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstAsmStructsAsm.asm	(revision 28800)
@@ -8,5 +8,5 @@
 
 ;
-; Copyright (C) 2006-2007 Sun Microsystems, Inc.
+; Copyright (C) 2006-2007 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
@@ -17,8 +17,4 @@
 ; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 ; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-;
-; Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
-; Clara, CA 95054 USA or visit http://www.sun.com if you need
-; additional information or have any questions.
 ;
 
Index: trunk/src/VBox/VMM/testcase/tstCFGM.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstCFGM.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstCFGM.cpp	(revision 28800)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2007 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstCompiler.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstCompiler.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstCompiler.cpp	(revision 28800)
@@ -8,5 +8,5 @@
 
 /*
- * Copyright (C) 2006-2007 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2007 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -17,8 +17,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstCompressionBenchmark.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstCompressionBenchmark.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstCompressionBenchmark.cpp	(revision 28800)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2009 Sun Microsystems, Inc.
+ * Copyright (C) 2009 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstGlobalConfig.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstGlobalConfig.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstGlobalConfig.cpp	(revision 28800)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2007 Sun Microsystems, Inc.
+ * Copyright (C) 2007 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstHelp.h
===================================================================
--- trunk/src/VBox/VMM/testcase/tstHelp.h	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstHelp.h	(revision 28800)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2007 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstInstrEmul.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstInstrEmul.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstInstrEmul.cpp	(revision 28800)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2007 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstMMHyperHeap.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstMMHyperHeap.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstMMHyperHeap.cpp	(revision 28800)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2007 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstMicro.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstMicro.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstMicro.cpp	(revision 28800)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2007 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstMicro.h
===================================================================
--- trunk/src/VBox/VMM/testcase/tstMicro.h	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstMicro.h	(revision 28800)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2007 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstMicro.mac
===================================================================
--- trunk/src/VBox/VMM/testcase/tstMicro.mac	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstMicro.mac	(revision 28800)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Sun Microsystems, Inc.
+; Copyright (C) 2006-2007 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
 ; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 ; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-;
-; Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
-; Clara, CA 95054 USA or visit http://www.sun.com if you need
-; additional information or have any questions.
 ;
 
Index: trunk/src/VBox/VMM/testcase/tstMicroRC.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstMicroRC.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstMicroRC.cpp	(revision 28800)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2007 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstMicroRC.def
===================================================================
--- trunk/src/VBox/VMM/testcase/tstMicroRC.def	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstMicroRC.def	(revision 28800)
@@ -3,5 +3,5 @@
 ; VMM Guest Context Micro Benchmark - Definition file.
 
-; Copyright (C) 2006-2007 Sun Microsystems, Inc.
+; Copyright (C) 2006-2007 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
@@ -12,8 +12,4 @@
 ; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 ; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-;
-; Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
-; Clara, CA 95054 USA or visit http://www.sun.com if you need
-; additional information or have any questions.
 ;
 
Index: trunk/src/VBox/VMM/testcase/tstMicroRCA.asm
===================================================================
--- trunk/src/VBox/VMM/testcase/tstMicroRCA.asm	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstMicroRCA.asm	(revision 28800)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Sun Microsystems, Inc.
+; Copyright (C) 2006-2007 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
 ; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 ; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-;
-; Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
-; Clara, CA 95054 USA or visit http://www.sun.com if you need
-; additional information or have any questions.
 ;
 
Index: trunk/src/VBox/VMM/testcase/tstPDMAsyncCompletion.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstPDMAsyncCompletion.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstPDMAsyncCompletion.cpp	(revision 28800)
@@ -10,5 +10,5 @@
 
 /*
- * Copyright (C) 2008-2010 Sun Microsystems, Inc.
+ * Copyright (C) 2008-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -19,8 +19,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstPDMAsyncCompletionStress.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstPDMAsyncCompletionStress.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstPDMAsyncCompletionStress.cpp	(revision 28800)
@@ -7,5 +7,5 @@
 
 /*
- * Copyright (C) 2008-2009 Sun Microsystems, Inc.
+ * Copyright (C) 2008-2009 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -16,8 +16,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstSSM.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstSSM.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstSSM.cpp	(revision 28800)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2007 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstVMM-HwAccm.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstVMM-HwAccm.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstVMM-HwAccm.cpp	(revision 28800)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2007 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstVMM.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstVMM.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstVMM.cpp	(revision 28800)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2007 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstVMMFork.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstVMMFork.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstVMMFork.cpp	(revision 28800)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2007 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstVMMR0CallHost-1.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstVMMR0CallHost-1.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstVMMR0CallHost-1.cpp	(revision 28800)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2007 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstVMREQ.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstVMREQ.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstVMREQ.cpp	(revision 28800)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2007 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,8 +14,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstVMStructRC.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstVMStructRC.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstVMStructRC.cpp	(revision 28800)
@@ -9,5 +9,5 @@
 
 /*
- * Copyright (C) 2006-2010 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -18,8 +18,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
Index: trunk/src/VBox/VMM/testcase/tstVMStructSize.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstVMStructSize.cpp	(revision 28262)
+++ trunk/src/VBox/VMM/testcase/tstVMStructSize.cpp	(revision 28800)
@@ -7,5 +7,5 @@
 
 /*
- * Copyright (C) 2006-2007 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2007 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -16,8 +16,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 