Index: trunk/src/VBox/Runtime/include/internal/path.h
===================================================================
--- trunk/src/VBox/Runtime/include/internal/path.h	(revision 28800)
+++ trunk/src/VBox/Runtime/include/internal/path.h	(revision 28877)
@@ -48,12 +48,14 @@
  * Converts a path from IPRT to native representation.
  *
- * This may involve querying filesystems what codeset they
- * speak and so forth.
+ * This may involve querying filesystems what codeset they speak and so forth.
  *
  * @returns IPRT status code.
  * @param   ppszNativePath  Where to store the pointer to the native path.
  *                          Free by calling rtPathFreeHost(). NULL on failure.
+ *                          Can be the same as pszPath.
  * @param   pszPath         The path to convert.
- * @remark  This function is not available on hosts using something else than byte seqences as names. (eg win32)
+ *
+ * @remark  This function is not available on hosts using something else than
+ *          byte seqences as names (eg win32).
  */
 int rtPathToNative(char **ppszNativePath, const char *pszPath);
@@ -62,13 +64,16 @@
  * Converts a path from IPRT to native representation.
  *
- * This may involve querying filesystems what codeset they
- * speak and so forth.
+ * This may involve querying filesystems what codeset they speak and so forth.
  *
  * @returns IPRT status code.
  * @param   ppszNativePath  Where to store the pointer to the native path.
- *                          Free by calling rtPathFreeHost(). NULL on failure.
+ *                          Free by calling rtPathFreeHost().  NULL on failure.
+ *                          Can be the same as pszPath.
  * @param   pszPath         The path to convert.
- * @param   pszBasePath     What pszPath is relative to. If NULL the function behaves like rtPathToNative().
- * @remark  This function is not available on hosts using something else than byte seqences as names. (eg win32)
+ * @param   pszBasePath     What pszPath is relative to. If NULL the function
+ *                          behaves like rtPathToNative().
+ *
+ * @remark  This function is not available on hosts using something else than
+ *          byte seqences as names (eg win32).
  */
 int rtPathToNativeEx(char **ppszNativePath, const char *pszPath, const char *pszBasePath);
@@ -78,7 +83,11 @@
  *
  * @param   pszNativePath   The host path to free. NULL allowed.
- * @remark  This function is not available on hosts using something else than byte seqences as names. (eg win32)
+ * @param   pszPath         The original path.  This is for checking if
+ *                          rtPathToNative returned the pointer to the original.
+ *
+ * @remark  This function is not available on hosts using something else than
+ *          byte seqences as names (eg win32).
  */
-void rtPathFreeNative(char *pszNativePath);
+void rtPathFreeNative(char *pszNativePath, const char *pszPath);
 
 /**
@@ -89,5 +98,7 @@
  *                          Free by calling RTStrFree(). NULL on failure.
  * @param   pszNativePath   The native path to convert.
- * @remark  This function is not available on hosts using something else than byte seqences as names. (eg win32)
+ *
+ * @remark  This function is not available on hosts using something else than
+ *          byte seqences as names (eg win32).
  */
 int rtPathFromNative(char **ppszPath, const char *pszNativePath);
@@ -100,7 +111,10 @@
  *                          Free by calling RTStrFree(). NULL on failure.
  * @param   pszNativePath   The native path to convert.
- * @param   pszBasePath     What pszHostPath is relative to - in IPRT representation.
- *                          If NULL the function behaves like rtPathFromNative().
- * @remark  This function is not available on hosts using something else than byte seqences as names. (eg win32)
+ * @param   pszBasePath     What pszHostPath is relative to - in IPRT
+ *                          representation.  If NULL the function behaves like
+ *                          rtPathFromNative().
+ *
+ * @remark  This function is not  available on hosts using something else than
+ *          byte seqences as names (eg win32).
  */
 int rtPathFromNativeEx(char **ppszPath, const char *pszNativePath, const char *pszBasePath);